aboutsummaryrefslogtreecommitdiff
path: root/tools/test
diff options
context:
space:
mode:
Diffstat (limited to 'tools/test')
-rwxr-xr-xtools/test/stress2/misc/zfs12.sh133
-rwxr-xr-xtools/test/stress2/misc/zfs13.sh82
-rw-r--r--tools/test/stress2/tools/lsholes.c86
3 files changed, 301 insertions, 0 deletions
diff --git a/tools/test/stress2/misc/zfs12.sh b/tools/test/stress2/misc/zfs12.sh
new file mode 100755
index 000000000000..cfabca2b9f6f
--- /dev/null
+++ b/tools/test/stress2/misc/zfs12.sh
@@ -0,0 +1,133 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# lseek(SEEK_HOLE): finds hole
+# Test scenario suggestion by: kib@
+# Related to:
+# Bug 256205 - ZFS: data corruption with SEEK_HOLE/SEEK_DATA on dirty files ...
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+kldstat -v | grep -q zfs.ko || { kldload zfs.ko; loaded=1; } ||
+ exit 0
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+sed '1,/^EOF/d' < $here/$0 > zfs12.c
+mycc -o zfs12 -Wall -Wextra -O0 -g zfs12.c || exit 1
+rm -f zfs12.c
+cc -o /tmp/lsholes -Wall -Wextra -O2 $here/../tools/lsholes.c | exit 1
+
+mp1=/stress2_tank/test
+u1=$mdstart
+u2=$((u1 + 1))
+
+set -e
+mdconfig -l | grep -q md$u1 && mdconfig -d -u $u1
+mdconfig -l | grep -q md$u2 && mdconfig -d -u $u2
+
+mdconfig -s 2g -u $u1
+mdconfig -s 2g -u $u2
+
+zpool list | egrep -q "^stress2_tank" && zpool destroy stress2_tank
+[ -d /stress2_tank ] && rm -rf /stress2_tank
+zpool create stress2_tank md$u1 md$u2
+zfs create stress2_tank/test
+set +e
+
+(cd $here/../testcases/swap; ./swap -t 2m -i 20 -l 100 -h > /dev/null) &
+file1=$mp1/file # zfs path
+sleep 20
+/tmp/zfs12 $file1
+/tmp/lsholes $file1
+s=$?
+while pkill swap; do sleep 1; done
+wait
+
+zfs umount stress2_tank/test
+zfs destroy -r stress2_tank
+zpool destroy stress2_tank
+mdconfig -d -u $u1
+mdconfig -d -u $u2
+rm -f /tmp/zfs12 /tmp/lsholes
+[ $loaded ] && kldunload zfs.ko
+exit $s
+EOF
+#include <sys/types.h>
+#include <err.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <sys/mman.h>
+#include <sys/param.h>
+#include <string.h>
+#include <unistd.h>
+#include <errno.h>
+
+#define SIZ (500UL * 1024 * 1024)
+
+int
+main(int argc __unused, char *argv[])
+{
+ off_t hole;
+ size_t len;
+ int fd;
+ char *p, *path;
+
+ len = SIZ;
+
+ path = argv[1];
+ if ((fd = open(path, O_CREAT | O_TRUNC | O_RDWR, 0622)) == -1)
+ err(1,"open()");
+ if (ftruncate(fd, len) == -1)
+ err(1, "ftruncate");
+ if ((p = mmap(NULL, len, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0)) ==
+ MAP_FAILED) {
+ if (errno == ENOMEM)
+ return (1);
+ err(1, "mmap(1)");
+ }
+ p[1 * 1024] = 1;
+ p[2 * 1024] = 1;
+ p[4 * 1024] = 1;
+
+ if (msync(p, len, MS_SYNC | MS_INVALIDATE) == -1)
+ err(1, "msync()");
+
+ if ((hole = lseek(fd, 0, SEEK_HOLE)) == -1)
+ err(1, "lseek(SEEK_HOLE)");
+ if (hole != SIZ)
+ printf("--> hole = %jd, file size=%jd\n",
+ (intmax_t)hole, (intmax_t)SIZ);
+ close(fd);
+
+ return (hole == SIZ ? 0 : 1);
+}
diff --git a/tools/test/stress2/misc/zfs13.sh b/tools/test/stress2/misc/zfs13.sh
new file mode 100755
index 000000000000..2ccd4388270d
--- /dev/null
+++ b/tools/test/stress2/misc/zfs13.sh
@@ -0,0 +1,82 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# Sparse files test.
+# Delayed write observed.
+# Related to:
+# Bug 256205 - ZFS: data corruption with SEEK_HOLE/SEEK_DATA on dirty files ...
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+kldstat -v | grep -q zfs.ko || { kldload zfs.ko; loaded=1; } ||
+ exit 0
+
+. ../default.cfg
+
+here=`pwd`
+cd /tmp
+mycc -o /tmp/lsholes -Wall -Wextra -O0 -g $here/../tools/lsholes.c || exit 1
+
+log1=/tmp/zfs13.sh.1.log
+log2=/tmp/zfs13.sh.2.log
+mp1=/stress2_tank/test
+u1=$mdstart
+u2=$((u1 + 1))
+
+set -e
+mdconfig -l | grep -q md$u1 && mdconfig -d -u $u1
+mdconfig -l | grep -q md$u2 && mdconfig -d -u $u2
+
+mdconfig -s 2g -u $u1
+mdconfig -s 2g -u $u2
+
+zpool list | egrep -q "^stress2_tank" && zpool destroy stress2_tank
+[ -d /stress2_tank ] && rm -rf /stress2_tank
+zpool create stress2_tank md$u1 md$u2
+zfs create stress2_tank/test
+set +e
+
+cd $mp1
+dd if=/etc/passwd conv=notrunc oseek=32k of=output status=none
+ls -ls | grep output | tee $log1
+/tmp/lsholes output
+sleep 10
+ls -ls | grep output | tee $log2
+/tmp/lsholes output
+cd $here
+
+zfs umount stress2_tank/test
+zfs destroy -r stress2_tank
+zpool destroy stress2_tank
+mdconfig -d -u $u1
+mdconfig -d -u $u2
+cmp -s $log1 $log2
+s=$?
+rm -f /tmp/lsholes $log1 $log2
+[ $loaded ] && kldunload zfs.ko
+exit $s
diff --git a/tools/test/stress2/tools/lsholes.c b/tools/test/stress2/tools/lsholes.c
new file mode 100644
index 000000000000..a583c1315093
--- /dev/null
+++ b/tools/test/stress2/tools/lsholes.c
@@ -0,0 +1,86 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+ *
+ * Copyright (c) 2021 Peter Holm <pho@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/param.h>
+#include <sys/stat.h>
+
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+int
+main(int argc, char *argv[])
+{
+ struct stat st;
+ off_t data, hole, pos;
+ long mx;
+ int fd, n;
+ char *name;
+
+ if (argc != 2) {
+ fprintf(stderr, "Usage: %s <file>\n", argv[0]);
+ exit(1);
+ }
+
+ name = argv[1];
+ if ((fd = open(name, O_RDONLY)) == -1)
+ err(1, "open(%s)", name);
+ if (fstat(fd, &st))
+ err(1, "fstat()");
+ if ((mx = fpathconf(fd, _PC_MIN_HOLE_SIZE)) == -1)
+ err(1, "fpathconf()");
+ fprintf(stderr, "file \"%s\" size = %jd, _PC_MIN_HOLE_SIZE = %ld\n",
+ name, (intmax_t)st.st_size, mx);
+ n = 1;
+ pos = 0;
+ while (pos < st.st_size) {
+ if ((hole = lseek(fd, pos, SEEK_HOLE)) == -1)
+ err(1, "lseek(SEEK_HOLE)");
+ if ((data = lseek(fd, hole, SEEK_DATA)) == -1) {
+ if (errno == ENXIO) {
+ if (hole == st.st_size)
+ break;
+ fprintf(stderr,
+ "No data after hole @ %jd\n",
+ (intmax_t)hole);
+ break;
+ }
+ err(1, "lseek(SEEK_DATA)");
+ }
+ pos = data;
+ printf("hole #%d @ %jd (0x%jx), size=%jd (0x%jx)\n",
+ n, (intmax_t)hole, (intmax_t)hole, (intmax_t)(data - hole),
+ (intmax_t)(data - hole));
+ n++;
+ }
+ close(fd);
+ if (hole != st.st_size)
+ errx(1, "No implicit hole at EOF");
+}